CF1029E Tree with Small Distances 题解

题意简述

给定一颗有根树(根节点为 1 1 1)。要求往树中加入一些边使得从根节点到其他节点的距离至多是 2 2 2。求加入边的最小数量。(边全部都是无向的)

解题思路

还是采用贪心的思路。

对于一个到根节点的距离大于 2 2 2 的叶子节点,我们只有两种方法使它到根节点的距离小于等于 2 2 2,要么直接连它和根节点,要么连接它的父亲和根节点。比较显然的是,如果连接它的父亲和根节点,一定不劣于连接它和根节点。

然后接下来这一步和其他题解说的都不太一样。大部分题解在得出贪心的策略后是把所有点按深度排序,然后开始贪心。但是根据我们上面推出的东西,我们只需要保证每次处理的是叶子节点就可以,这启示我们使用拓扑排序。

具体地,先 dfs 一遍求出每个点的父亲,然后进行拓扑排序,将拓扑排序的结果记录下来,进行贪心即可。

由于不需要排序,所以时间复杂度其实是优于其他题解所述的贪心。

代码示例

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;
#define int long long
int n,vis[200010],ans=0,du[200010],fa[200010],num[200010],cnt=0;
vector<int> G[200010];
void dfs(int u,int Fa){
	fa[u]=Fa;
	for(int v:G[u]) if(v!=Fa) dfs(v,u);
}
signed main(){
	cin>>n;
	for(int i=1;i<=n-1;i++){
		int u,v;
		cin>>u>>v;
		G[u].push_back(v);
		G[v].push_back(u);
		du[u]++,du[v]++;
	}
	dfs(1,0);//找父亲
	vis[1]=1;
	for(int u:G[1]){
		vis[u]=1;
		for(int v:G[u]) vis[v]=1;
	}
    //把根节点周围先标记了
	queue<int> q;
	for(int i=1;i<=n;i++) if(!vis[i]&&du[i]==1) q.push(i);
	while(!q.empty()){
		int u=q.front();q.pop();
		num[++cnt]=u;
		for(int v:G[u]){
			du[v]--;
			if(du[v]==1) q.push(v);
		}
	}
    //拓扑
	for(int i=1;i<=cnt;i++){
		int u=num[i];
		if(vis[u]) continue;
		vis[fa[u]]=1;
		ans++;
		for(int v:G[fa[u]]) vis[v]=1;
	}
    //贪心
	cout<<ans<<endl;
	return 0;
}
相关推荐
垆边人似月.1 分钟前
华为题:敏感词替换
算法
0+11110 分钟前
算法 --哈希表
数据结构·算法·散列表
Interview Aid1121 小时前
Stripe VO 面经汇总:5 轮面试题目与考察重点
算法
EEET智选1 小时前
科技晨间速报 | AI 安全警钟、开源新模型与苹果智能家居
人工智能·科技·算法·机器学习·ai
挖掘狂人1 小时前
哈希算法:一根看不见的 "指纹",如何撑起整个互联网
算法·程序员·掘金技术征文
鶴哥只手遮天1 小时前
ecRad 1.5.0 算法原理详解
算法·开源
不会就选b2 小时前
算法日常・每日刷题--<动态规划>22
算法·动态规划
释厄6232 小时前
字画同体论——字即画·几何即字·漫画与小说=文本层
人工智能·算法
沫璃染墨2 小时前
从零入门数据结构与算法(一):复杂度分析——从算法效率到时间与空间复杂度
c语言·开发语言·数据结构·笔记·算法·飞书
熊猫钓鱼>_>2 小时前
面试出现 606 次的第 K 大,被拆成三个问题问
算法·面试·职场和发展·校招·面经·oj·ai生成